Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.gradle
[Java] Class StartParameter

    java.lang.Object
      org.gradle.StartParameter

    public class StartParameter

`StartParameter` defines the configuration used by a GradleLauncher instance to execute a build. The properties of `StartParameter` generally correspond to the command-line options of Gradle. You pass a `StartParameter` instance to GradleLauncher#newInstance(StartParameter)#newInstance(StartParameter) when you create a new `Gradle` instance.

You can obtain an instance of a `StartParameter` by either creating a new one, or duplicating an existing one using newInstance or newBuild.

Authors:
  Hans Dockter

See Also:
  GradleLauncher

Nested Class Summary
`enum` | `StartParameter.ShowStacktrace`

Field Summary
`static java.io.File` | `DEFAULT_GRADLE_USER_HOME` The default user home directory.
`static java.lang.String` | `GRADLE_USER_HOME_PROPERTY_KEY`

Constructor Summary
`StartParameter()` Creates a `StartParameter` with default values.

Method Summary
`void` | `addInitScript(java.io.File initScriptFile)` Adds the given file to the list of init scripts that are run before the build starts.
`boolean` | `equals(java.lang.Object obj)`
`BuildExecuter` | `getBuildExecuter()` Returns the BuildExecuter to use for the build.
`java.io.File` | `getBuildFile()` Returns the build file to use to select the default project.
`ScriptSource` | `getBuildScriptSource()` Returns the ScriptSource to use for the build file for this build.
`CacheUsage` | `getCacheUsage()`
`java.io.File` | `getCurrentDir()` Returns the directory to use to select the default project, and to search for the settings file.
`ProjectSpec` | `getDefaultProjectSelector()` Returns the selector used to choose the default project of the build.
`java.util.Set` | `getExcludedTaskNames()` Returns the names of the tasks to be excluded from this build.
`java.io.File` | `getGradleUserHomeDir()` Returns the directory to use as the user home directory.
`java.util.List` | `getInitScripts()` Returns all explicitly added init scripts that will be run before the build starts.
`LogLevel` | `getLogLevel()`
`ProjectDependenciesBuildInstruction` | `getProjectDependenciesBuildInstruction()`
`java.util.Map` | `getProjectProperties()`
`ScriptSource` | `getSettingsScriptSource()` Returns the ScriptSource to use for the settings script for this build.
`StartParameter.ShowStacktrace` | `getShowStacktrace()`
`java.util.Map` | `getSystemPropertiesArgs()`
`java.util.List` | `getTaskNames()` Returns the names of the tasks to execute in this build.
`int` | `hashCode()`
`boolean` | `isDryRun()`
`boolean` | `isLaunchGUI()` Determines whether or not the GUI was requested to be launched.
`boolean` | `isNoOpt()`
`boolean` | `isSearchUpwards()`
`boolean` | `isShowHelp()`
`boolean` | `isShowVersion()`
`StartParameter` | `newBuild()` Creates the parameters for a new build, using these parameters as a template.
`StartParameter` | `newInstance()` Duplicates this `StartParameter` instance.
`void` | `setBuildExecuter(BuildExecuter buildExecuter)` Sets the BuildExecuter to use for the build.
`void` | `setBuildFile(java.io.File buildFile)` Sets the build file to use to select the default project.
`StartParameter` | `setBuildScriptSource(ScriptSource buildScript)` Specifies that the given script should be used as the build file for this build.
`void` | `setCacheUsage(CacheUsage cacheUsage)`
`void` | `setCurrentDir(java.io.File currentDir)` Sets the directory to use to select the default project, and to search for the settings file.
`void` | `setDefaultProjectSelector(ProjectSpec defaultProjectSelector)` Sets the selector used to choose the default project of the build.
`void` | `setDryRun(boolean dryRun)`
`void` | `setExcludedTaskNames(java.util.Collection excludedTaskNames)` Sets the tasks to exclude from this build.
`void` | `setGradleUserHomeDir(java.io.File gradleUserHomeDir)` Sets the directory to use as the user home directory.
`void` | `setInitScripts(java.util.List initScripts)`
`void` | `setLaunchGUI(boolean launchGUI)`
`void` | `setLogLevel(LogLevel logLevel)`
`void` | `setNoOpt(boolean noOpt)`
`void` | `setProjectDependenciesBuildInstruction(ProjectDependenciesBuildInstruction projectDependenciesBuildInstruction)`
`void` | `setProjectDir(java.io.File projectDir)` Sets the project directory to use to select the default project.
`void` | `setProjectProperties(java.util.Map projectProperties)`
`void` | `setSearchUpwards(boolean searchUpwards)`
`void` | `setSettingsFile(java.io.File settingsFile)` Sets the settings file to use for the build.
`void` | `setSettingsScriptSource(ScriptSource settingsScriptSource)` Sets the ScriptSource to use for the settings script.
`void` | `setShowHelp(boolean showHelp)`
`void` | `setShowStacktrace(StartParameter.ShowStacktrace showStacktrace)`
`void` | `setShowVersion(boolean showVersion)`
`void` | `setSystemPropertiesArgs(java.util.Map systemPropertiesArgs)`
`void` | `setTaskNames(java.util.Collection taskNames)` Sets the tasks to execute in this build.
`java.lang.String` | `toString()`
`StartParameter` | `useEmbeddedBuildFile(java.lang.String buildScriptText)` Specifies that the given script should be used as the build file for this build.

Methods inherited from class java.lang.Object
java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Field Detail

### DEFAULT_GRADLE_USER_HOME

    public static final java.io.File DEFAULT_GRADLE_USER_HOME

  The default user home directory.

### GRADLE_USER_HOME_PROPERTY_KEY

    public static final java.lang.String GRADLE_USER_HOME_PROPERTY_KEY

Constructor Detail

### StartParameter

    public StartParameter()

  Creates a `StartParameter` with default values. This is roughly equivalent to running Gradle on the command-line with no arguments.

Method Detail

### addInitScript

    public void addInitScript(java.io.File initScriptFile)

  Adds the given file to the list of init scripts that are run before the build starts. This list is in addition to the user init script located in ${user.home}/.gradle/init.gradle.
  Parameters:
    `initScriptFile` - The init script to be run during the Gradle invocation.

### equals

    public boolean equals(java.lang.Object obj)

### getBuildExecuter

    public BuildExecuter getBuildExecuter()

  Returns the BuildExecuter to use for the build.

  Returns:
    The BuildExecuter. Never returns null.

### getBuildFile

    public java.io.File getBuildFile()

  Returns the build file to use to select the default project. Returns null when the build file is not used to select the default project.
  Returns:
    The build file. May be null.

### getBuildScriptSource

    public ScriptSource getBuildScriptSource()

  Returns the ScriptSource to use for the build file for this build. Returns null when the default build file(s) are to be used. This source is used for all projects included in the build.

  Returns:
    The build file source, or null to use the defaults.

### getCacheUsage

    public CacheUsage getCacheUsage()

### getCurrentDir

    public java.io.File getCurrentDir()

  Returns the directory to use to select the default project, and to search for the settings file.
  Returns:
    The current directory. Never returns null.

### getDefaultProjectSelector

    public ProjectSpec getDefaultProjectSelector()

  Returns the selector used to choose the default project of the build. This is the project used as the starting point for resolving task names, and for determining the default tasks.
  Returns:
    The default project. Never returns null.

### getExcludedTaskNames

    public java.util.Set getExcludedTaskNames()

  Returns the names of the tasks to be excluded from this build. When empty, no tasks are excluded from the build.
  Returns:
    The names of the excluded tasks. Returns an empty set if there are no such tasks.

### getGradleUserHomeDir

    public java.io.File getGradleUserHomeDir()

  Returns the directory to use as the user home directory.
  Returns:
    The home directory.

### getInitScripts

    public java.util.List getInitScripts()

  Returns all explicitly added init scripts that will be run before the build starts. This list does not contain the user init script located in ${user.home}/.gradle/init.gradle, even though that init script will also be run.
  Returns:
    list of all explicitly added init scripts.

### getLogLevel

    public LogLevel getLogLevel()

### getProjectDependenciesBuildInstruction

    public ProjectDependenciesBuildInstruction getProjectDependenciesBuildInstruction()

### getProjectProperties

    public java.util.Map getProjectProperties()

### getSettingsScriptSource

    public ScriptSource getSettingsScriptSource()

  Returns the ScriptSource to use for the settings script for this build. Returns null when the default settings script is to be used.

  Returns:
    The settings script source, or null to use the default.

### getShowStacktrace

    public StartParameter.ShowStacktrace getShowStacktrace()

### getSystemPropertiesArgs

    public java.util.Map getSystemPropertiesArgs()

### getTaskNames

    public java.util.List getTaskNames()

  Returns the names of the tasks to execute in this build. When empty, the default tasks for the project will be executed.
  Returns:
    the names of the tasks to execute in this build. Never returns null.

### hashCode

    public int hashCode()

### isDryRun

    public boolean isDryRun()

### isLaunchGUI

    public boolean isLaunchGUI()

  Determines whether or not the GUI was requested to be launched.

### isNoOpt

    public boolean isNoOpt()

### isSearchUpwards

    public boolean isSearchUpwards()

### isShowHelp

    public boolean isShowHelp()

### isShowVersion

    public boolean isShowVersion()

### newBuild

    public StartParameter newBuild()

  Creates the parameters for a new build, using these parameters as a template. Copies the environmental properties from this parameter (eg gradle user home dir, etc), but does not copy the build specific properties (eg task names).

  Returns:
    The new parameters.

### newInstance

    public StartParameter newInstance()

  Duplicates this `StartParameter` instance.
  Returns:
    the new parameters.

### setBuildExecuter

    public void setBuildExecuter(BuildExecuter buildExecuter)

  Sets the BuildExecuter to use for the build. You can use the method to change the algorithm used to execute the build, by providing your own `BuildExecuter` implementation.

  Set to null to use the default executer. When this property is set to a non-null value, the taskNames and mergedBuild properties are ignored.

  Parameters:
    `buildExecuter` - The executer to use, or null to use the default executer.

### setBuildFile

    public void setBuildFile(java.io.File buildFile)

  Sets the build file to use to select the default project. Use null to disable selecting the default project using the build file.
  Parameters:
    `buildFile` - The build file. May be null.

### setBuildScriptSource

    public StartParameter setBuildScriptSource(ScriptSource buildScript)

  Specifies that the given script should be used as the build file for this build. Uses an empty settings file.

  Parameters:
    `buildScript` - The script to use as the build file.
  Returns:
    this

### setCacheUsage

    public void setCacheUsage(CacheUsage cacheUsage)

### setCurrentDir

    public void setCurrentDir(java.io.File currentDir)

  Sets the directory to use to select the default project, and to search for the settings file. Set to null to use the default current directory.
  Parameters:
    `currentDir` - The directory. Should not be null.

### setDefaultProjectSelector

    public void setDefaultProjectSelector(ProjectSpec defaultProjectSelector)

  Sets the selector used to choose the default project of the build.
  Parameters:
    `defaultProjectSelector` - The selector. Should not be null.

### setDryRun

    public void setDryRun(boolean dryRun)

### setExcludedTaskNames

    public void setExcludedTaskNames(java.util.Collection excludedTaskNames)

  Sets the tasks to exclude from this build.
  Parameters:
    `excludedTaskNames` - The task names. Can be null.

### setGradleUserHomeDir

    public void setGradleUserHomeDir(java.io.File gradleUserHomeDir)

  Sets the directory to use as the user home directory. Set to null to use the default directory.
  Parameters:
    `gradleUserHomeDir` - The home directory. May be null.

### setInitScripts

    public void setInitScripts(java.util.List initScripts)

### setLaunchGUI

    public void setLaunchGUI(boolean launchGUI)

### setLogLevel

    public void setLogLevel(LogLevel logLevel)

### setNoOpt

    public void setNoOpt(boolean noOpt)

### setProjectDependenciesBuildInstruction

    public void setProjectDependenciesBuildInstruction(ProjectDependenciesBuildInstruction projectDependenciesBuildInstruction)

### setProjectDir

    public void setProjectDir(java.io.File projectDir)

  Sets the project directory to use to select the default project. Use null to use the default criteria for selecting the default project.
  Parameters:
    `projectDir` - The project directory. May be null.

### setProjectProperties

    public void setProjectProperties(java.util.Map projectProperties)

### setSearchUpwards

    public void setSearchUpwards(boolean searchUpwards)

### setSettingsFile

    public void setSettingsFile(java.io.File settingsFile)

  Sets the settings file to use for the build. Use null to use the default settings file.
  Parameters:
    `settingsFile` - The settings file to use. May be null.

### setSettingsScriptSource

    public void setSettingsScriptSource(ScriptSource settingsScriptSource)

  Sets the ScriptSource to use for the settings script. Set to null to use the default settings script.

  Parameters:
    `settingsScriptSource` - The settings script source.

### setShowHelp

    public void setShowHelp(boolean showHelp)

### setShowStacktrace

    public void setShowStacktrace(StartParameter.ShowStacktrace showStacktrace)

### setShowVersion

    public void setShowVersion(boolean showVersion)

### setSystemPropertiesArgs

    public void setSystemPropertiesArgs(java.util.Map systemPropertiesArgs)

### setTaskNames

    public void setTaskNames(java.util.Collection taskNames)

  Sets the tasks to execute in this build. Set to an empty list, or null, to execute the default tasks for the project. The tasks are executed in the order provided, subject to dependency between the tasks.

  Parameters:
    `taskNames` - the names of the tasks to execute in this build.

### toString

    @Override
    public java.lang.String toString()

### useEmbeddedBuildFile

    public StartParameter useEmbeddedBuildFile(java.lang.String buildScriptText)

  Specifies that the given script should be used as the build file for this build. Uses an empty settings file.

  Parameters:
    `buildScriptText` - The script to use as the build file.
  Returns:
    this

Groovy Documentation